package com.jasamedika.medifirst2000.entities;

import java.io.Serializable;
import org.hibernate.envers.Audited;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.*;

import org.hibernate.validator.constraints.NotEmpty;

import com.jasamedika.medifirst2000.base.BaseMaster;
import javax.validation.constraints.NotNull;
import org.hibernate.validator.constraints.Length;
import org.hibernate.validator.internal.util.logging.Messages;

import com.fasterxml.jackson.annotation.JsonManagedReference;
import com.jasamedika.medifirst2000.base.BaseMaster;
import com.jasamedika.medifirst2000.helper.Caption;
import org.hibernate.envers.Audited;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;

/**
 * class MetodePenyusutan
 * 
 * @author Generator
 */
@Entity // @Audited
@Table(name = "MetodePenyusutan_M")
public class MetodePenyusutan extends BaseMaster {
	@ManyToOne
	@JoinColumn(name = "ObjectDepartemenFk")
	@NotNull(message = "Object Departemen Harus Diisi")
	@Caption(value = "Object Departemen")
	private Departemen departemen;

	public void setDepartemen(Departemen departemen) {
		this.departemen = departemen;
	}

	@NotNull(message = "Kd Departemen tidak boleh kosong")

	public Departemen getDepartemen() {
		return this.departemen;
	}

	@Column(name = "ObjectDepartemenFk", insertable = false, updatable = false)
	private Integer departemenId;

	@Caption(value = "Kode Metode Penyusutan")
	private Byte kdMetodePenyusutan;

	public void setKdMetodePenyusutan(Byte kdMetodePenyusutan) {
		this.kdMetodePenyusutan = kdMetodePenyusutan;
	}

	@NotNull(message = "Kd Metode Penyusutan tidak boleh kosong")
	@Column(name = "KdMetodePenyusutan", nullable = false)
	public Byte getKdMetodePenyusutan() {
		return this.kdMetodePenyusutan;
	}

	@Caption(value = "Metode Penyusutan")
	private String metodePenyusutan;

	public void setMetodePenyusutan(String metodePenyusutan) {
		this.metodePenyusutan = metodePenyusutan;
	}

	@NotNull(message = "Metode Penyusutan tidak boleh kosong")
	@Column(name = "MetodePenyusutan", nullable = false, length = 50)
	public String getMetodePenyusutan() {
		return this.metodePenyusutan;
	}

	@Caption(value = "Persen Penyusutan")
	private Double persenPenyusutan;

	public void setPersenPenyusutan(Double persenPenyusutan) {
		this.persenPenyusutan = persenPenyusutan;
	}

	@NotNull(message = "Persen Penyusutan tidak boleh kosong")
	@Column(name = "PersenPenyusutan", nullable = false)
	public Double getPersenPenyusutan() {
		return this.persenPenyusutan;
	}

	@Caption(value = "QMetode Penyusutan")
	private Byte qMetodePenyusutan;

	public void setqMetodePenyusutan(Byte qMetodePenyusutan) {
		this.qMetodePenyusutan = qMetodePenyusutan;
	}

	@NotNull(message = "QMetode Penyusutan tidak boleh kosong")
	@Column(name = "QMetodePenyusutan", nullable = false)
	public Byte getqMetodePenyusutan() {
		return this.qMetodePenyusutan;
	}

	@Caption(value = "Rumus Penyusutan")
	private String rumusPenyusutan;

	public void setRumusPenyusutan(String rumusPenyusutan) {
		this.rumusPenyusutan = rumusPenyusutan;
	}

	@Column(name = "RumusPenyusutan", nullable = true, length = 20)
	public String getRumusPenyusutan() {
		return this.rumusPenyusutan;
	}

	/*
	 * @JsonManagedReference
	 * 
	 * @OneToMany(fetch = FetchType.LAZY, cascade = CascadeType.ALL, mappedBy =
	 * "kdmetodepenyusutan") private Set<KelompokAset> KelompokAsetSet = new
	 * HashSet<KelompokAset>();
	 * 
	 * public Set<KelompokAset> getKelompokAsetSet() { return KelompokAsetSet; }
	 * 
	 * public void setKelompokAsetSet(Set<KelompokAset> kelompokAsetSet) {
	 * KelompokAsetSet = kelompokAsetSet; }
	 */

	@Id
	@GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "public.metodepenyusutan_m_id_seq")
	@javax.persistence.SequenceGenerator(name = "public.metodepenyusutan_m_id_seq", sequenceName = "public.metodepenyusutan_m_id_seq", allocationSize = 1)
	@Column(name = "id")
	protected Integer id;

	public Integer getId() {

		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}
}